//
// @author vay
// @email hxhvay@126.com
// @date 2020-07-06
//

import 'package:flutter/material.dart';
import 'package:flutter_localizations/flutter_localizations.dart';
import 'package:vaycore/dartin.dart';
import 'package:vaycore/modules.dart';
import 'package:vaycore/src/core/i_vc_engine.dart';
import 'package:vaycore/src/modules/locale/i_vc_locale_holder.dart';
import 'package:vaycore/src/modules/locale/vc_locale_holder.dart';
import 'package:vaycore/src/utils/widget_utils.dart';

/// VayCore引擎类
class VCEngine extends IVCEngine {
  @override
  IVCThemeHolder buildThemeHolder() => inject<VCThemeHolder>();

  @override
  IVCLocaleHolder buildLocaleHolder() => inject<VCLocaleHolder>();

  @override
  List<VCComponentBuilder> registerFactoryComponents() {
    return [];
  }

  @override
  List<VCComponentBuilder> registerSingleComponents() {
    return [];
  }

  @override
  buildRootWidget() {
    return MaterialApp(
      theme: ThemeData(
        primarySwatch: VCTheme.getTheme(),
      ),
      locale: VCLocale.getLocale(),
      home: WidgetUtils.textScaleDisable(
        Scaffold(
          body: Center(
            child: Text(
              "hello vaycore!",
              style: TextStyle(
                fontSize: 20,
                color: VCTheme.getTheme(),
              ),
            ),
          ),
        ),
      ),
      localizationsDelegates: [
        GlobalMaterialLocalizations.delegate,
        GlobalWidgetsLocalizations.delegate,
        VCLocaleDelegate.delegate,
      ],
      supportedLocales: VCLocale.supportLocales,
      localeResolutionCallback: VCLocale.localeResolutionCallback,
    );
  }
}
