//
// @author vay
// @email hxhvay@126.com
// @date 2020-05-13
//

import 'package:flutter/material.dart';
import 'package:flutter/foundation.dart';

import 'package:vaycore/modules.dart';

/// Locale代理类
class VCLocaleDelegate extends LocalizationsDelegate<Object> {
  const VCLocaleDelegate();

  @override
  bool isSupported(Locale locale) {
    // 判断列表是否包含传递过来的Locale
    return VCLocale.supportLocales.any(
      (element) => element.languageCode == locale.languageCode,
    );
  }

  @override
  Future<Object> load(Locale locale) {
    return new SynchronousFuture<Object>(new Object());
  }

  @override
  bool shouldReload(LocalizationsDelegate<Object> old) {
    return false;
  }

  static VCLocaleDelegate delegate = const VCLocaleDelegate();
}
