//
// @author vay
// @email hxhvay@126.com
// @date 2020-07-07
//

import 'package:vaycore/core.dart';
import 'package:vaycore/src/utils/shared_preferences_utils.dart';

/// 配置组件
abstract class IProfileComponent<T> extends VCComponent {
  /// 配置对应的key
  String get profileKey;

  /// 配置数据
  T _data;

  IProfileComponent() {
    _data = SpUtils.get(profileKey);
  }

  T get data => _data;

  set data(T data) {
    if (this.data != data) {
      this.data = data;
      SpUtils.put<T>(profileKey, data);
    }
  }

  Future<bool> clear() async {
    bool result = await SpUtils.remove(profileKey);
    if (result) {
      this.data = null;
    }
    return result;
  }
}
