//
// @author vay
// @email hxhvay@126.com
// @date 2020-07-06
//

import 'package:flutter/material.dart';
import 'package:vaycore/modules.dart';

/// 主题业务接口
abstract class IVCThemeHolder extends IProfileComponent<int> {
  /// 可选主题色
  List<ColorSwatch> get themes;

  @override
  onInit() {}

  /// 获取当前配置的主题
  ColorSwatch readTheme() {
    return themes.firstWhere(
      (e) => e.value == data,
      orElse: () => themes.first,
    );
  }

  /// 配置一个新的主题
  saveTheme(ColorSwatch color) {
    int newTheme = color.value;
    if (data != newTheme) {
      data = newTheme;
    }
  }
}
