//
// @author vay
// @email hxhvay@126.com
// @date 2020-05-12
//

import 'package:flutter/cupertino.dart';

/// 点击事件
abstract class Presenter {
  /// 处理点击事件
  ///
  /// 可根据 [action] 进行区分 ,[action] 应是不可变的量
  void onClick(String action);

  /// 获取事件回调
  GestureTapCallback tap(String action) {
    return () => this.onClick(action);
  }
}

/// ListView Item Click
abstract class ItemPresenter<T> {
  /// 处理列表点击事件
  ///
  /// 可根据 [action] 进行区分 ,[action] 应是不可变的量
  void onItemClick(String action, T item);
}
