//
// @author vay
// @email hxhvay@126.com
// @date 2020-05-15
//

import 'package:flutter/services.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import 'package:vaycore/vaycore.dart';

/// 栏相关
class BarUtils {
  static StatusBarStyle _statusBarStyle;

  /// 不允许实例化
  BarUtils._();

  /// 获取状态栏高度
  static double getStatusBarHeight() {
    return MediaQuery.of(core.context).padding.top;
  }

  /// 设置状态栏图标风格
  static setStatusBarStyle(StatusBarStyle style) {
    SystemUiOverlayStyle uiStyle = style == StatusBarStyle.dark
        ? SystemUiOverlayStyle.dark
        : SystemUiOverlayStyle.light;
    // Android状态栏透明
    uiStyle = uiStyle.copyWith(statusBarColor: Colors.transparent);
    if (style == null || style == _statusBarStyle) {
      return;
    }
    _statusBarStyle = style;
    SystemChrome.setSystemUIOverlayStyle(uiStyle);
  }

  /// 获取状态栏图标风格，在调用[setStatusBarStyle]后有效
  static StatusBarStyle getStatusBarStyle() {
    return _statusBarStyle;
  }
}

/// 状态栏图标风格
enum StatusBarStyle {
  /// 黑色图标
  dark,

  /// 白色图标
  light,
}
