//
// @author vay
// @email hxhvay@126.com
// @date 2020-05-09
//

library vaycore;

import 'package:flutter/material.dart';
import 'package:vaycore/common.dart';
import 'package:vaycore/core.dart';
import 'package:vaycore/utils.dart';

/// 组件主类
class VayCore {
  /// 单例
  static VayCore _instance = new VayCore._internal();

  /// 私有构造函数
  VayCore._internal();

  /// 工厂构造函数
  factory VayCore() => _instance;

  /// 调式模式
  bool _isDebug;

  bool get isDebug => this._isDebug;

  /// 页面BuildContext对象
  BuildContext context;

  /// VayCore引擎
  IVCEngine _engine;

  IVCEngine get engine => this._engine;

  /// 加载
  void load({bool isDebug = false, IVCEngine engine}) async {
    this._engine = engine ?? VCEngine();
    this._isDebug = isDebug;
    InnerWidgetsFlutterBinding.ensureInitialized();
    await _init();
    InnerWidgetsFlutterBinding.ensureInitialized()
      ..attachRootWidget(engine.buildRootWidget())
      ..scheduleWarmUpFrame();
  }

  /// 初始化
  _init() async {
    await AppUtils.init();
    await SpUtils.init();
    await engine.onInit();
  }
}

/// 全局实例
VayCore core = new VayCore();
